
--[==[

WELCOME TO ALERI

]==]--


--main addon tables
Aleri = {}
Aleri.Merchant = {}
Aleri.Mail = {}
Aleri.Chat = {}

Aleri.Guild = {}
Aleri.Guild.Members = {}
--these should be condensed into a db table rather than arr tables
Aleri.Guild.ClassCountMaxLevel = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
Aleri.Guild.ClassCountNorthrend = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
Aleri.Guild.ClassCountOutland = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
Aleri.Guild.ClassCountVanilla = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
Aleri.Guild.ClassCountEveryone = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
Aleri.Guild.ShowDataRange = 'max'
Aleri.Guild.RaidStatsSort = 'MainSpecGearScore'
Aleri.ThisPlayer = {}

Aleri.Class = {}
Aleri.Class.IDs = { 'DEATHKNIGHT', 'WARRIOR', 'DRUID', 'PALADIN', 'PRIEST', 'SHAMAN', 'HUNTER', 'MAGE', 'ROGUE', 'WARLOCK', 'Total' }
Aleri.Class.Colours = {
	DEATHKNIGHT = { r = 0.77, g = 0.12, b = 0.23 },
	DRUID = { r = 1.00, g = 0.49, b = 0.04 },
	HUNTER = { r = 0.67, g = 0.83, b = 0.45 },
	MAGE = { r = 0.25, g = 0.78, b = 0.92 },
	PALADIN = { r = 0.96, g = 0.55, b = 0.73 },
	PRIEST = { r = 1.00, g = 1.00, b = 1.00 },
	ROGUE = { r = 1.00, g = 0.96, b = 0.41 },
	SHAMAN = { r = 0.00, g = 0.44, b = 0.87 },
	WARLOCK = { r = 0.53, g = 0.53, b =	0.93 },
	WARRIOR = { r = 0.78, g = 0.61, b = 0.43 },
	Total = { r = 1, g = 1, b = 1 }
}
Aleri.Class.HealerIDs = { 'PRIEST', 'DRUID', 'SHAMAN', 'PALADIN', 'Total' }
Aleri.Class.TankIDs = { 'DEATHKNIGHT', 'WARRIOR', 'DRUID', 'PALADIN', 'Total' }
Aleri.Class.MeleeDpsIDs = { 'DEATHKNIGHT', 'WARRIOR', 'DRUID', 'PALADIN', 'SHAMAN', 'ROGUE', 'Total' }
Aleri.Class.RangeDpsIDs = { 'PRIEST', 'DRUID', 'SHAMAN', 'HUNTER', 'MAGE', 'WARLOCK', 'Total' }
Aleri.Class.SpecRoles = {
	DRUID = { boom = 'Range', resto = 'Healer', feral = 'Melee', bear = 'Tank' },
	SHAMAN = { ele = 'Range', enh = 'Melee', resto = 'Healer' },
	HUNTER = { mm = 'Range', bm = 'Range', surv = 'Range' },
	PALADIN = { holy = 'Healer', prot = 'Tank', ret = 'Melee' },
	WARRIOR = { arms = 'Melee', fury = 'Melee', prot = 'Tank' },
	ROGUE = { ass = 'Melee', comb = 'Melee', subt = 'Melee' },
	PRIEST = { holy = 'Healer', disc = 'Healer', shad = 'Range' },
	WARLOCK = { demo = 'Range', aff = 'Range', dest = 'Range' },
	MAGE = { frost = 'Range', fire = 'Range', arc = 'Range' },
	DEATHKNIGHT = { frost = 'Tank', blood = 'Tank', unholy = 'Melee' },
}
Aleri.Class.SpecToDisplayText = {
	DRUID = { boom = 'Boomkin', resto = 'Restoration', feral = 'Feral Cat', bear = 'Feral Bear', unknown = 'Unknown', pvp = 'PvP' },
	SHAMAN = { ele = 'Elemental', enh = 'Enhance', resto = 'Restoration', unknown = 'Unknown', pvp = 'PvP' },
	HUNTER = { mm = 'Marksmanship', bm = 'Beast Master', surv = 'Survival', unknown = 'Unknown', pvp = 'PvP' },
	PALADIN = { holy = 'Holy', prot = 'Protection', ret = 'Retribution', unknown = 'Unknown', pvp = 'PvP' },
	WARRIOR = { arms = 'Arms', fury = 'Fury', prot = 'Protection', unknown = 'Unknown', pvp = 'PvP' },
	ROGUE = { ass = 'Assassination', comb = 'Combat', subt = 'Subtlety', unknown = 'Unknown', pvp = 'PvP' },
	PRIEST = { holy = 'Holy', disc = 'Discipline', shad = 'Shadow', unknown = 'Unknown', pvp = 'PvP' },
	WARLOCK = { demo = 'Demonology', aff = 'Affliction', dest = 'Destruction', unknown = 'Unknown', pvp = 'PvP' },
	MAGE = { frost = 'Frost', fire = 'Fire', arc = 'Arcane', unknown = 'Unknown', pvp = 'PvP' },
	DEATHKNIGHT = { frost = 'Frost', blood = 'Blood', unholy = 'Unholy', unknown = 'Unknown', pvp = 'PvP' },
}

--used to find incorrectly entered info in guild member notes
Aleri.GearScoreCheck = { '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '.' }
Aleri.LetterCheck = { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z' }

--main frame to register events
Aleri.MainFrame = CreateFrame('FRAME', 'AleriMainFrame', UIParent)
Aleri.MainFrame:RegisterEvent("CHAT_MSG_GUILD")
Aleri.MainFrame:RegisterEvent("CHAT_MSG_WHISPER")
Aleri.MainFrame:RegisterEvent("ADDON_LOADED")
Aleri.MainFrame:RegisterEvent("GUILD_ROSTER_UPDATE")

-------------------------------------------------------------------------------------------------------
-- Helper tools
-------------------------------------------------------------------------------------------------------
function Aleri.GetArgs(...)
	for i=1, select("#", ...) do
		arg = select(i, ...)
		print(i.." "..tostring(arg))
	end
end

function Aleri.MakeFrameMove(frame)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
end



function Aleri.LockFramePos(frame)
	frame:SetMovable(false)
end
-------------------------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------------------------
-- Player functions
-------------------------------------------------------------------------------------------------------
function Aleri.PrintPlayerXP()
	local xp = UnitXP('player')
	local xpmx = UnitXPMax('player')
	local xpr = GetXPExhaustion()
	if xpr == nil then xpr = 0 end
	return ('This Level: '..string.format("%.2f", (xp/xpmx) * 100)..'%'..' XP To Ding: '..tonumber(xpmx-xp)..' Rested XP: '..tonumber(xpr))
end

function Aleri.PrintGuildPlayerInfo(guid)
	local class, _, race, _, gender, name, _ = GetPlayerInfoByGUID(guid)
	if gender == 2 then gender = 'male' else gender = 'female' end
	for i = 1, GetNumGuildMembers() do
		if select(1, GetGuildRosterInfo(i)) == name then
			local level = select(4, GetGuildRosterInfo(i))
			print(name, '>', race, '>', class, '>', gender, '>', level)
		end
	end
end
-------------------------------------------------------------------------------------------------------

-------------------------------------------------------------------------------------------------------
-- Update class role summary panel
-------------------------------------------------------------------------------------------------------
function Aleri.Guild.RoleUpdate(sort_level, main_spec, off_spec)
	for k, player in ipairs(Aleri.Guild.Members) do
		if sort_level == 'max' then
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:GetChecked() == 1 then
				if player.Level == 80 then
					if player.MainSpecRole ~= nil then
						Aleri.Guild[player.MainSpecRole..'Count'][player.Class] = Aleri.Guild[player.MainSpecRole..'Count'][player.Class] + 1
					end
				end
			end
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox:GetChecked() == 1 then
				if player.Level == 80 then
					if player.OffSpecRole ~= nil then
						Aleri.Guild[player.OffSpecRole..'Count'][player.Class] = Aleri.Guild[player.OffSpecRole..'Count'][player.Class] + 1
					end
				end
			end
		elseif sort_level == 'northrend' then
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:GetChecked() == 1 then
				if player.Level < 80 and player.Level > 69 then
					if player.MainSpecRole ~= nil then
						Aleri.Guild[player.MainSpecRole..'Count'][player.Class] = Aleri.Guild[player.MainSpecRole..'Count'][player.Class] + 1
					end
				end
			end
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox:GetChecked() == 1 then
				if player.Level == 80 then
					if player.OffSpecRole ~= nil then
						Aleri.Guild[player.OffSpecRole..'Count'][player.Class] = Aleri.Guild[player.OffSpecRole..'Count'][player.Class] + 1
					end
				end
			end
		elseif sort_level == 'outland' then
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:GetChecked() == 1 then
				if player.Level < 70 and player.Level > 59 then
					if player.MainSpecRole ~= nil then
						Aleri.Guild[player.MainSpecRole..'Count'][player.Class] = Aleri.Guild[player.MainSpecRole..'Count'][player.Class] + 1
					end
				end
			end
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox:GetChecked() == 1 then
				if player.Level == 80 then
					if player.OffSpecRole ~= nil then
						Aleri.Guild[player.OffSpecRole..'Count'][player.Class] = Aleri.Guild[player.OffSpecRole..'Count'][player.Class] + 1
					end
				end
			end
		elseif sort_level == 'vanilla' then
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:GetChecked() == 1 then
				if player.Level < 60  then
					if player.MainSpecRole ~= nil then
						Aleri.Guild[player.MainSpecRole..'Count'][player.Class] = Aleri.Guild[player.MainSpecRole..'Count'][player.Class] + 1
					end
				end
			end
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox:GetChecked() == 1 then
				if player.Level == 80 then
					if player.OffSpecRole ~= nil then
						Aleri.Guild[player.OffSpecRole..'Count'][player.Class] = Aleri.Guild[player.OffSpecRole..'Count'][player.Class] + 1
					end
				end
			end
		elseif sort_level == 'everyone' then
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:GetChecked() == 1 then
				if player.MainSpecRole ~= nil then
					Aleri.Guild[player.MainSpecRole..'Count'][player.Class] = Aleri.Guild[player.MainSpecRole..'Count'][player.Class] + 1
				end
			end
			if Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox:GetChecked() == 1 then
				if player.OffSpecRole ~= nil then
					Aleri.Guild[player.OffSpecRole..'Count'][player.Class] = Aleri.Guild[player.OffSpecRole..'Count'][player.Class] + 1
				end
			end
		end		
	end
end

-------------------------------------------------------------------------------------------------------
-- Main guild frame update function - need to restructure this and move some parts into their own functions
-------------------------------------------------------------------------------------------------------
function Aleri.GuildInfo(sort_level)
	--update roster
	GuildRoster()	
	--should be made into a db table not arr table
	Aleri.Guild.HealerCount = { PRIEST = 0, DRUID = 0, SHAMAN = 0, PALADIN = 0, Total = 0 }
	Aleri.Guild.TankCount = { DEATHKNIGHT = 0, WARRIOR = 0, DRUID = 0, PALADIN = 0, Total = 0 }
	Aleri.Guild.MeleeCount = { DEATHKNIGHT = 0, WARRIOR = 0, DRUID = 0, PALADIN = 0, SHAMAN = 0, ROGUE = 0, Total = 0 }
	Aleri.Guild.RangeCount = { PRIEST = 0, DRUID = 0, SHAMAN = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, Total = 0 }
	
	--get member counts
	local TotalMembers, OnlineMemebrs, _ = GetNumGuildMembers()
	--clear old data
	for i = #Aleri.Guild.Members, 1, -1 do
		table.remove(Aleri.Guild.Members, i)
	end
	--loop members and extract info
	for i = 1, TotalMembers do
		local name, rankName, rankIndex, level, classDisplayName, zone, publicNote, officerNote, isOnline, status, class, achievementPoints, achievementRank, isMobile, canSoR, repStanding, guid = GetGuildRosterInfo(i)
		if rankIndex == 1 then
			Aleri.ThisPlayer['RankIndex'] = 1
		end
		local main_spec, ms_gs, off_spec, os_gs, net, tot, hrs
		local alt = nil
		local yearsOffline, monthsOffline, daysOffline, hoursOffline = GetGuildRosterLastOnline(i)
		
		-- if publicNote == '' then
			-- print(publicNote)
			-- GuildRosterSetPublicNote(i, '- - - -')
		-- end
		
		--potential to highlight players offline over X days
		--if daysOffline ~= nil and daysOffline > 7 then print(name) end
		--parse notes and convert into data
		-- PUBLIC NOTES SHOULD FOLLOW THIS FORMAT - main-main_spec gs off-main_spec gs prof-1 rank prof-2 rank (prof not enabled or developed yet but is an option)
		if publicNote ~= nil then
			local i = 1
			for data in string.gmatch(publicNote, "%S+") do
				if i == 1 then 
					if data == '-' then
						main_spec = 'unknown'
					else
						main_spec = string.lower(data)
					end
				end
				if i == 2 then
					if data == '-' then
						ms_gs = 0
					else
						ms_gs = string.sub(data, 1, 3)
					end
				end
				if i == 3 then 
					if data == '-' then 
						off_spec = 'unknown'
					else
						off_spec = string.lower(data) 
					end
				end
				if i == 4 then
					if data == '-' then
						os_gs = 0
					else
						os_gs = string.sub(data, 1, 3)
					end
				end
				i = i + 1
			end
		end
		if officerNote ~= nil then
			local i = 1
			for data in string.gmatch(officerNote, "%S+") do
				if i == 1 then
					if string.find(data, 'Net:') then
						net = string.sub(data, 5)
					else
						alt = data --if the first string in officer note doesn't match 'Net:' then its assumed to be an alt so we set the alt/main here
					end
				end
				if i == 2 then tot = string.sub(data, 5)
					if string.find(data, 'Tot:') then
						tot = string.sub(data, 5)
					end
				end
				if i == 3 then hrs = string.sub(data, 5)
					if string.find(data, 'Hrs:') then
						hrs = string.sub(data, 5)
					end
				end
				i = i + 1
			end
		end
		--if player is for pvp - this may be something to modify in time -------->>>>>>>>>>>>>>>>>  ADJUST THIS TO USE A DROP DOWN -> ALL AND 80 ONLY

		local ms_role = Aleri.Class.SpecRoles[class][main_spec]
		local os_role = Aleri.Class.SpecRoles[class][off_spec]
		
		--add member to main db
		table.insert(Aleri.Guild.Members, { Name = name, Level = level, Class = class, MainSpec = Aleri.Class.SpecToDisplayText[class][main_spec], MainSpecRole = ms_role, MainSpecGearScore = ms_gs, OffSpec = Aleri.Class.SpecToDisplayText[class][off_spec], OffSpecGearScore = os_gs, OffSpecRole = os_role, DKP = tot, Alt = alt } )
	end
	
	local show_main_spec = Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:GetChecked()
	local show_off_spec = Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox:GetChecked()
	
	--update the role counts
	Aleri.Guild.RoleUpdate(sort_level, show_main_spec, show_off_spec)
		
	--update spec and role display
	for class, count in pairs(Aleri.Guild.HealerCount) do
		if class ~= 'Total' then
			Aleri.Guild.SpecRoleCountFontString.Healer[class]:SetText(count)
		end
	end
	for class, count in pairs(Aleri.Guild.TankCount) do
		if class ~= 'Total' then
			Aleri.Guild.SpecRoleCountFontString.Tank[class]:SetText(count)
		end
	end
	for class, count in pairs(Aleri.Guild.MeleeCount) do
		if class ~= 'Total' then
			Aleri.Guild.SpecRoleCountFontString.Melee[class]:SetText(count)
		end
	end
	for class, count in pairs(Aleri.Guild.RangeCount) do
		if class ~= 'Total' then
			Aleri.Guild.SpecRoleCountFontString.Range[class]:SetText(count)
		end
	end
	--find each class for different level ranges and update counts
	for k, p in ipairs(Aleri.Guild.Members) do
		Aleri.Guild.ClassCountEveryone.Total = Aleri.Guild.ClassCountEveryone.Total + 1
		Aleri.Guild.ClassCountEveryone[p.Class] = Aleri.Guild.ClassCountEveryone[p.Class] + 1
		if p.Level == 80 then
			Aleri.Guild.ClassCountMaxLevel.Total = Aleri.Guild.ClassCountMaxLevel.Total + 1
			Aleri.Guild.ClassCountMaxLevel[p.Class] = Aleri.Guild.ClassCountMaxLevel[p.Class] + 1
		elseif p.Level > 69 and p.Level < 80 then
			Aleri.Guild.ClassCountNorthrend.Total = Aleri.Guild.ClassCountNorthrend.Total + 1
			Aleri.Guild.ClassCountNorthrend[p.Class] = Aleri.Guild.ClassCountNorthrend[p.Class] + 1
		elseif p.Level > 59 and p.Level < 70 then
			Aleri.Guild.ClassCountOutland.Total = Aleri.Guild.ClassCountOutland.Total + 1
			Aleri.Guild.ClassCountOutland[p.Class] = Aleri.Guild.ClassCountOutland[p.Class] + 1
		elseif p.Level < 60 then
			Aleri.Guild.ClassCountVanilla.Total = Aleri.Guild.ClassCountVanilla.Total + 1
			Aleri.Guild.ClassCountVanilla[p.Class] = Aleri.Guild.ClassCountVanilla[p.Class] + 1
		end
	end
	--clear sorted temp table and add the level range to be sorted
	Aleri.Guild.ClassCountSorted = {}
	local max_percent = 0
	if sort_level == 'max' then
		max_percent = Aleri.Guild.ClassCountMaxLevel.Total
		for k, c in pairs(Aleri.Guild.ClassCountMaxLevel) do
			--print(k, c)
			table.insert(Aleri.Guild.ClassCountSorted, { Class = k, Count = c } )
		end
	elseif sort_level == 'northrend' then
		max_percent = Aleri.Guild.ClassCountNorthrend.Total
		for k, c in pairs(Aleri.Guild.ClassCountNorthrend) do
			--print(k, c)
			table.insert(Aleri.Guild.ClassCountSorted, { Class = k, Count = c } )
		end	
	elseif sort_level == 'outland' then
		max_percent = Aleri.Guild.ClassCountOutland.Total
		for k, c in pairs(Aleri.Guild.ClassCountOutland) do
			--print(k, c)
			table.insert(Aleri.Guild.ClassCountSorted, { Class = k, Count = c } )
		end	
	elseif sort_level == 'vanilla' then
		max_percent = Aleri.Guild.ClassCountVanilla.Total
		for k, c in pairs(Aleri.Guild.ClassCountVanilla) do
			--print(k, c)
			table.insert(Aleri.Guild.ClassCountSorted, { Class = k, Count = c } )
		end
	elseif sort_level == 'everyone' then
		max_percent = Aleri.Guild.ClassCountEveryone.Total
		for k, c in pairs(Aleri.Guild.ClassCountEveryone) do
			--print(k, c)
			table.insert(Aleri.Guild.ClassCountSorted, { Class = k, Count = c } )
		end
	end		
	--sort table to display highest at top
	table.sort(Aleri.Guild.ClassCountSorted, function(a,b) return a.Count > b.Count end)
	--update class summary by level display
	for k, v in ipairs(Aleri.Guild.ClassCountSorted) do
		--print(k, v.Class, v.Count)
			Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k]:SetText(v.Class)
			Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k]:SetTextColor(Aleri.Class.Colours[v.Class].r, Aleri.Class.Colours[v.Class].g, Aleri.Class.Colours[v.Class].b)
			Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k]:SetText(v.Count)
			Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k]:SetTextColor(Aleri.Class.Colours[v.Class].r, Aleri.Class.Colours[v.Class].g, Aleri.Class.Colours[v.Class].b)
			Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k]:SetText(string.format("%.2f", ((v.Count/ max_percent) * 100))..'%')
			Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k]:SetTextColor(Aleri.Class.Colours[v.Class].r, Aleri.Class.Colours[v.Class].g, Aleri.Class.Colours[v.Class].b)
			Aleri.Guild.PlayerFrameClassStatusBars[k]:SetValue((v.Count/ max_percent) * 100)
			Aleri.Guild.PlayerFrameClassStatusBars[k]:SetStatusBarColor(Aleri.Class.Colours[v.Class].r, Aleri.Class.Colours[v.Class].g, Aleri.Class.Colours[v.Class].b)
	end
	--clear temp table
	for i = #Aleri.Guild.ClassCountSorted, 1, -1 do
		table.remove(Aleri.Guild.ClassCountSorted, i)
	end
	--reset counts (see note above about condensing into db)
	Aleri.Guild.ClassCountMaxLevel = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
	Aleri.Guild.ClassCountNorthrend = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
	Aleri.Guild.ClassCountOutland = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
	Aleri.Guild.ClassCountVanilla = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }
	Aleri.Guild.ClassCountEveryone = { Total = 0, WARRIOR = 0, PALADIN = 0, PRIEST = 0, HUNTER = 0, MAGE = 0, WARLOCK = 0, DEATHKNIGHT = 0, SHAMAN = 0, DRUID = 0, ROGUE = 0 }

end
-------------------------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------------------------
-- Raid stats listview function - sorts listview by sort value
-------------------------------------------------------------------------------------------------------
function Aleri.GuildRaidStatsInfo(sort)
	
	if sort == 'refresh' then
		sort = Aleri.Guild.RaidStatsSort
	end
	
	if Aleri.Guild.PlayerFrame.RaidStatsGridView ~= nil then
		local row = nil
		for i = #Aleri.Guild.PlayerFrame.RaidStatsGridView, 1, -1 do
			row = Aleri.Guild.PlayerFrame.RaidStatsGridView[i]			
			row.ClassIcon:Hide()
			row.Id:SetText(' ')
			row.Name:SetText(' ')
			row.MainSpec:SetText(' ')
			row.MainSpecGearScore:SetText(' ')
			row.OffSpec:SetText(' ')
			row.OffSpecGearScore:SetText(' ')
			row.DKP:SetText(' ')
		end
	end
	
	--temp sort table
	Aleri.Guild.RaidStatsSorted = {}
	
	--apply corrections prior to sort, officers note and public not may be in wrong format
	for k, p in ipairs(Aleri.Guild.Members) do
			
		--remove nil entries
		if p.MainSpecGearScore == nil then p.MainSpecGearScore = 0 end
		--if p.Net == nil then p.Net = 0 end
		if p.Tot == nil then p.Tot = 0 end
		--if p.Hrs == nil then p.Hrs = 0 end
		
		--filter for wrong decimal symbol
		if string.find(p.MainSpecGearScore, ',') then
			p.MainSpecGearScore = tostring(string.sub(p.MainSpecGearScore, 1, 1)..'.'..string.sub(p.MainSpecGearScore, 3, 3))
		end
		
		--remove letters
		for it, l in pairs(Aleri.LetterCheck) do
			if string.find(p.MainSpecGearScore, l) or string.find(p.MainSpecGearScore, string.upper(l)) then
					p.MainSpecGearScore = 0
					--print(p.Name, p.MainSpecGearScore)
			end
			-- if string.find(p.Net, l) or string.find(p.Net, string.upper(l)) then
					-- p.Net = 0
					-- --print(p.Name, p.Net)
				-- end
			if string.find(p.Tot, l) or string.find(p.Tot, string.upper(l)) then
					p.Tot = 0
					--print(p.Name, p.Tot)
			end
			-- if string.find(p.Hrs, l) or string.find(p.Hrs, string.upper(l)) then
					-- p.Hrs = 0
					-- --print(p.Name, p.Hrs)
				-- end
		end
		-- alt check
		if p.Alt ~= nil then
			p.DKP = 0
		end	
		
		--add member to db
		if p.Level == 80 then
			table.insert(Aleri.Guild.RaidStatsSorted, { Level = p.Level, Class = p.Class, Name = p.Name, Alt = p.Alt, MainSpec = p.MainSpec, MainSpecGearScore = tonumber(p.MainSpecGearScore), OffSpec = p.OffSpec, OffSpecGearScore = tonumber(p.OffSpecGearScore), DKP = tonumber(p.DKP) } )
		end
		--print( p.GearScore, p.Net, p.Tot, p.Hrs )
	end
	
	for k, v in ipairs(Aleri.Guild.RaidStatsSorted) do
		if v.DKP == nil then
			print(v.Name, v.DKP)
		end
	end
	
	
	
	--check sort and apply either alphabetical or numerical sort
	if sort == 'Class' or sort == 'Name' or sort == 'MainSpec' or sort == 'OffSpec' then 
		table.sort(Aleri.Guild.RaidStatsSorted, function(a,b)  return a[sort] < b[sort] end) -- a -> z print( a.Name, a[sort], b.name, b[sort])
	else
		table.sort(Aleri.Guild.RaidStatsSorted, function(a,b)  return a[sort] > b[sort] end)	-- 9 -> 0 print(sort, a.Name, a[sort], b.name, b[sort])
	end
	--update listview display
	local row_id = 1
	local row_height = 25
	local vertical_row_offset = 8
	for r, player in ipairs(Aleri.Guild.RaidStatsSorted) do
		--adjust fontstring if member is an alt
		if player.Level == 80 then
			-- if player.Alt ~= nil then
				-- player.Net = player.Alt
				-- player.Tot = ' '
				-- player.Hrs = ' '
			-- end
			--if fontstring exist - update it
			if Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id] ~= nil then
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Id:SetText(row_id)			
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].ClassIcon:Show()				
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].ClassIcon.Texture:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..player.Class)				
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Name:SetText(player.Name)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Name:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].MainSpec:SetText(player.MainSpec)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].MainSpec:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].MainSpecGearScore:SetText(player.MainSpecGearScore)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].MainSpecGearScore:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
				
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].OffSpec:SetText(player.OffSpec)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].OffSpec:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].OffSpecGearScore:SetText(player.OffSpecGearScore)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].OffSpecGearScore:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
				
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Net:SetText(player.Net)
				--adjust position of fonstring if member is an alt - stretch full width
				-- if player.Alt ~= nil then
					-- Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Net:SetWidth(100)
					-- Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Net:SetPoint('TOPLEFT', 308, ((row_id-1) * - row_height) - vertical_row_offset)
				-- else
					-- Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Net:SetPoint('TOPLEFT', 308, ((row_id-1) * - row_height) - vertical_row_offset) 
					-- Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Net:SetWidth(50)
				-- end
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].Net:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
				
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].DKP:SetText(player.DKP)
				Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].DKP:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
				
				if player.Alt ~= nil then
					Aleri.Guild.PlayerFrame.RaidStatsGridView[row_id].DKP:SetText(player.Alt)
				end
								
			else
			
				--[==[ LISTVIEW LAYOUT
				name		class	spec		gs		net		tot		hrs
				30		130		156		258		308		358		408
				]==]--
			
				--create new fonstring if not exist
				local row = { Id = nil, ClassIcon = nil, ClassIconTexture = nil, Name = nil, MainSpec = nil, MainSpecGearScore = nil, Net = nil, Tot = nil, Hrs = nil, OffSpec = nil, OffSpecGearScore = nil, Alt = nil, DKP = nil }
				for k, v in ipairs(Aleri.Guild.PlayerFrame.RaidStatsColumns) do
					--if not icon make fontstring
					local fs = nil
					local fs_name = nil
					if v ~= 'ClassIcon' then
						fs_name = '_'..v..k
						fs = Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent:CreateFontString('AleriGuildPlayerFrameRaidStatsGridView'..fs_name, 'OVERLAY', 'GameFontNormal')
						fs:SetText(player[v])
						fs:SetTextColor(Aleri.Class.Colours[player.Class].r, Aleri.Class.Colours[player.Class].g, Aleri.Class.Colours[player.Class].b)
						row[v] = fs
					end
					-- set class icon
					if v == 'ClassIcon' then						
						local iconFrame = CreateFrame('FRAME', 'AleriGuildPlayerFrameRaidStatsIcon'..k, Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent)
						iconFrame:SetPoint('TOPLEFT', 115, ((row_id-1) * - row_height) - (vertical_row_offset - 4))
						iconFrame:SetSize(24, 24)
						iconFrame.Texture = iconFrame:CreateTexture('$parent_Texture', 'BACKGROUND')
						iconFrame.Texture:SetAllPoints(iconFrame)
						iconFrame.Texture:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..player.Class)
						row['ClassIcon'] = iconFrame
					--set listview row id
					elseif v == 'Id' then
						fs:SetText(row_id)
						fs:SetTextColor(1,1,1)
						fs:SetPoint('TOPLEFT', 4, ((row_id-1) * - row_height) - vertical_row_offset)
						fs:SetWidth(24)
						fs:SetJustifyH('RIGHT')
						row[v] = fs
					--set all other columns
					elseif v == 'Name' then
						fs:SetPoint('TOPLEFT', 30, ((row_id-1) * - row_height) - vertical_row_offset)
					elseif v == 'MainSpec' then
						fs:SetPoint('TOPLEFT', 150, ((row_id-1) * - row_height) - vertical_row_offset)
					elseif v == 'MainSpecGearScore' then
						fs:SetPoint('TOPLEFT', 240, ((row_id-1) * - row_height) - vertical_row_offset)
					elseif v == 'OffSpec' then
						fs:SetPoint('TOPLEFT', 280, ((row_id-1) * - row_height) - vertical_row_offset)
					elseif v == 'OffSpecGearScore' then
						fs:SetPoint('TOPLEFT', 370, ((row_id-1) * - row_height) - vertical_row_offset)
					elseif v == 'DKP' then
						fs:SetPoint('TOPLEFT', 410, ((row_id-1) * - row_height) - vertical_row_offset)
						if player.Alt ~= nil then
							fs:SetText(player.Alt)
						end
						
						
					elseif v == 'Alt' then
					
					end
					
				end
				table.insert(Aleri.Guild.PlayerFrame.RaidStatsGridView, row)
			end
			row_id = row_id + 1
		end
	end
	--set new scroll frame height - NEED TO CHECK THIS AS LISTVIEW GROWS BIGGER
	Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent:SetHeight((row_id - 1) * (row_height))
	-- print('row height:', row_height, 'row count:', row_id)
	-- print('content frame height:', Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent:GetHeight())

end


-------------------------------------------------------------------------------------------------------
-- wait function - FOUND ONLINE AND WORK ONCE BUT NEVER SINCE WILL KEEP ON RESEARCHING IT
-------------------------------------------------------------------------------------------------------
local waitTable = {}
local waitFrame = nil

function Aleri.Wait(delay, func, ...)
  if(type(delay) ~= "number" or type(func) ~= "function") then
    return false
  end
  if not waitFrame then
    waitFrame = CreateFrame("Frame", nil, UIParent)
    waitFrame:SetScript("OnUpdate", function (self, elapse)
      for i = 1, #waitTable do
        local waitRecord = tremove(waitTable, i)
        local d = tremove(waitRecord, 1)
        local f = tremove(waitRecord, 1)
        local p = tremove(waitRecord, 1)
        if d > elapse then
          tinsert(waitTable, i, {d - elapse, f, p})
          i = i + 1
        else
          count = count - 1
          f(unpack(p))
        end
      end
    end)
  end
  tinsert(waitTable, {delay, func, {...}})
  return true
end
-------------------------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------------------------
-- Chat Functions - TO ENABLE THIS JUST UNCOMMENT IT ALL AND THE LINE IN THE EVENTS SECTION NEAR BOTTOM
-------------------------------------------------------------------------------------------------------
-- Aleri.Chat.GuildChatDropDown = CreateFrame("FRAME", "GuildChatFrameDropDown", UIParent, "UIDropDownMenuTemplate")
-- Aleri.Chat.GuildChatDropDown:SetPoint("TOPLEFT", 130, -93)
-- UIDropDownMenu_SetWidth(Aleri.Chat.GuildChatDropDown, 70)
-- UIDropDownMenu_SetText(Aleri.Chat.GuildChatDropDown, 'Guild')

-- Aleri.MakeFrameMove(Aleri.Chat.GuildChatDropDown)

-- function Aleri.Chat.GuildChatDropDown:Clicked(arg1, checked)
	-- SendChatMessage(arg1, 'GUILD')
-- end

-- Aleri.Chat.GuildChatDropDownMenuTable = {
	-- { ID = 1, Label = 'Hey', Message = 'Hey' },
	-- { ID = 2, Label = 'Cya', Message = 'Cya' },
-- }

-- function Aleri.Chat.GuildChatDropDown_Init()
	-- UIDropDownMenu_Initialize(Aleri.Chat.GuildChatDropDown, function(self, level, menuList)
		-- local info = UIDropDownMenu_CreateInfo()
		-- info.func = self.Clicked
		-- if level == 1 then
			-- for k, msg in ipairs(Aleri.Chat.GuildChatDropDownMenuTable) do			
				-- info.text, info.arg1, info.checked = msg.Label, msg.Message, false
				-- UIDropDownMenu_AddButton(info)
			-- end
		-- end
	-- end)
-- end
-------------------------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------------------------
-- Guild Info Frame - MAIN GUILD FRAME
-------------------------------------------------------------------------------------------------------
Aleri.Guild.PlayerFrame = CreateFrame('FRAME', 'AleriGuildPlayerFrame', GuildFrame)
Aleri.Guild.PlayerFrame:SetPoint("TOPLEFT", 350, -12)
Aleri.Guild.PlayerFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 20, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
Aleri.Guild.PlayerFrame:SetBackdropColor(0,0,0,1)
Aleri.Guild.PlayerFrame:SetSize(480, 425)

-- Aleri.Guild.PlayerFrame.ResizeButton = CreateFrame('BUTTON', 'AleriGuildPlayerFrameResizeButton', Aleri.Guild.PlayerFrame, "UIPanelButtonTemplate" )
-- Aleri.Guild.PlayerFrame.ResizeButton:SetPoint('TOPLEFT', 10, -10)
-- Aleri.Guild.PlayerFrame.ResizeButton:SetText('S')
-- Aleri.Guild.PlayerFrame.ResizeButton:SetSize(10, 10)

Aleri.Guild.ClassStatsFrame = CreateFrame('FRAME', 'AleriGuildClassStatsFrame', Aleri.Guild.PlayerFrame)
Aleri.Guild.ClassStatsFrame:SetPoint('TOPLEFT', 0, 0)
Aleri.Guild.ClassStatsFrame:SetSize(400, 320)

Aleri.Guild.PlayerFrameFontStrings_ColumnOne = {}
Aleri.Guild.PlayerFrameFontStrings_ColumnTwo = {}
Aleri.Guild.PlayerFrameFontStrings_ColumnThree = {}
Aleri.Guild.PlayerFrameClassStatusBars = {}

for k, v in ipairs(Aleri.Class.IDs) do
	Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k] = Aleri.Guild.ClassStatsFrame:CreateFontString('AleriGuildPlayerFrameFontString_'..k, 'OVERLAY', 'GameFontNormal')
	Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k]:SetPoint('TOPLEFT', 30, ((k-1) * -25) - 100)
	Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k]:SetText(v)
	Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k]:SetFont("Fonts\\FRIZQT__.TTF", 14)
	Aleri.Guild.PlayerFrameFontStrings_ColumnOne[k]:SetTextColor(Aleri.Class.Colours[v].r, Aleri.Class.Colours[v].g, Aleri.Class.Colours[v].b)
	
	Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k] = Aleri.Guild.ClassStatsFrame:CreateFontString('AleriGuildPlayerFrameFontString_'..k, 'OVERLAY', 'GameFontNormal')
	Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k]:SetPoint('TOPLEFT', 160, ((k-1) * -25) - 100)
	--Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k]:SetText(v)
	Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k]:SetFont("Fonts\\FRIZQT__.TTF", 14)
	Aleri.Guild.PlayerFrameFontStrings_ColumnTwo[k]:SetTextColor(Aleri.Class.Colours[v].r, Aleri.Class.Colours[v].g, Aleri.Class.Colours[v].b)
	
	Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k] = Aleri.Guild.ClassStatsFrame:CreateFontString('AleriGuildPlayerFrameFontString_'..k, 'OVERLAY', 'GameFontNormal')
	Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k]:SetPoint('TOPLEFT', 200, ((k-1) * -25) - 100)
	--Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k]:SetText(v)
	Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k]:SetFont("Fonts\\FRIZQT__.TTF", 14)
	Aleri.Guild.PlayerFrameFontStrings_ColumnThree[k]:SetTextColor(Aleri.Class.Colours[v].r, Aleri.Class.Colours[v].g, Aleri.Class.Colours[v].b)
	
	Aleri.Guild.PlayerFrameClassStatusBars[k] = CreateFrame("StatusBar", k..'_StatusBar', Aleri.Guild.ClassStatsFrame)
	Aleri.Guild.PlayerFrameClassStatusBars[k]:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	Aleri.Guild.PlayerFrameClassStatusBars[k]:GetStatusBarTexture():SetHorizTile(false)
	Aleri.Guild.PlayerFrameClassStatusBars[k]:SetMinMaxValues(0, 100)
	Aleri.Guild.PlayerFrameClassStatusBars[k]:SetValue(0)
	Aleri.Guild.PlayerFrameClassStatusBars[k]:SetSize(160,24)
	Aleri.Guild.PlayerFrameClassStatusBars[k]:SetPoint('TOPLEFT', 290, ((k-1) * -25) - 100)
	Aleri.Guild.PlayerFrameClassStatusBars[k]:SetStatusBarColor(Aleri.Class.Colours[v].r, Aleri.Class.Colours[v].g, Aleri.Class.Colours[v].b)	
end

-------------------------------------------------------------------------------------------------------
--DROP DOWN MENU AND TEXT
-------------------------------------------------------------------------------------------------------
Aleri.Guild.PlayerFrameDropDownText = Aleri.Guild.ClassStatsFrame:CreateFontString('AleriGuildPlayerFrameDropDownText', 'OVERLAY', 'GameFontNormal')
Aleri.Guild.PlayerFrameDropDownText:SetPoint('TOPLEFT', 20, -20)
Aleri.Guild.PlayerFrameDropDownText:SetText('Class Summary by Level')
Aleri.Guild.PlayerFrameDropDownText:SetTextColor(1,1,1)
Aleri.Guild.PlayerFrameDropDownText:SetFont("Fonts\\FRIZQT__.TTF", 18)

Aleri.Guild.PlayerFrameDropDown = CreateFrame("FRAME", "AleriGuildFrameDropDown", Aleri.Guild.PlayerFrame, "UIDropDownMenuTemplate")
Aleri.Guild.PlayerFrameDropDown:SetPoint("TOPRIGHT", -20, -20)
UIDropDownMenu_SetWidth(Aleri.Guild.PlayerFrameDropDown, 100)
UIDropDownMenu_SetText(Aleri.Guild.PlayerFrameDropDown, 'Level 80')

function Aleri.Guild.PlayerFrameDropDown:Clicked(arg1, arg2, checked)
	Aleri.GuildInfo(arg1)
	UIDropDownMenu_SetText(Aleri.Guild.PlayerFrameDropDown, arg2)
	Aleri.Guild.ShowDataRange = arg1
end

Aleri.Guild.PlayerFrameDropDownMenuTable = {
	{ ID = 1, Label = 'Level 80', Range = 'max' },
	{ ID = 2, Label = 'Level 70 - 79', Range = 'northrend' },
	{ ID = 3, Label = 'Level 60 - 69', Range = 'outland' },
	{ ID = 4, Label = 'Level 1 - 59', Range = 'vanilla' },
	{ ID = 5, Label = 'Everyone', Range = 'everyone' }
}

function Aleri.Guild.PlayerFrameDropDown_Init()
	UIDropDownMenu_Initialize(Aleri.Guild.PlayerFrameDropDown, function(self, level, menuList)
		local info = UIDropDownMenu_CreateInfo()
		info.func = self.Clicked
		if level == 1 then
			for k, opt in ipairs(Aleri.Guild.PlayerFrameDropDownMenuTable) do
				info.text, info.arg1, info.arg2, info.checked = opt.Label, opt.Range, opt.Label, false
				UIDropDownMenu_AddButton(info)
			end
		end
	end)
end
-------------------------------------------------------------------------------------------------------

-------------------------------------------------------------------------------------------------------
-- ROLE SUMMARY
-------------------------------------------------------------------------------------------------------

local font_scale = 1
local role_icon_offset = 2
local role_class_vert_offset = 115
local vert_spacing = 1
local icon_size = 35
local role_icons_left_margin = 30

Aleri.TankIcon = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:25:25:0:0:64:64:0:19:22:41|t"
Aleri.HealerIcon = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:25:25:0:0:64:64:20:39:1:20|t"
Aleri.DamageIcon = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:25:25:0:0:64:64:20:39:22:41|t"

Aleri.Guild.PlayerFrame.RoleFrame = CreateFrame('FRAME', 'AleriGuildPlayerFrameRoleFrame', Aleri.Guild.PlayerFrame)
Aleri.Guild.PlayerFrame.RoleFrame:SetPoint('TOPLEFT', 0, 0)
Aleri.Guild.PlayerFrame.RoleFrame:SetSize(400, 230)

Aleri.Guild.PlayerFrame.RoleFrameTitle = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameTitle', 'OVERLAY', 'GameFontNormal')
Aleri.Guild.PlayerFrame.RoleFrameTitle:SetPoint('TOPLEFT', 20, -20)
Aleri.Guild.PlayerFrame.RoleFrameTitle:SetText('Summary of Class, Spec & Roles')
Aleri.Guild.PlayerFrame.RoleFrameTitle:SetTextColor(1,1,1)
Aleri.Guild.PlayerFrame.RoleFrameTitle:SetFont("Fonts\\FRIZQT__.TTF", 18)

Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox = CreateFrame("CheckButton", 'AleriGuildPlayerFrameRoleFrameShowMainSpecCheckBox', Aleri.Guild.PlayerFrame.RoleFrame, "ChatConfigCheckButtonTemplate")
Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:SetPoint('TOPLEFT', 330, -70)
AleriGuildPlayerFrameRoleFrameShowMainSpecCheckBoxText:SetText('Main Spec')
Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:SetChecked(true)
Aleri.Guild.PlayerFrame.RoleFrame.ShowMainSpecCheckBox:SetScript('OnClick', function() Aleri.GuildInfo(Aleri.Guild.ShowDataRange) end)

Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox = CreateFrame("CheckButton", 'AleriGuildPlayerFrameRoleFrameShowOffSpecCheckBox', Aleri.Guild.PlayerFrame.RoleFrame, "ChatConfigCheckButtonTemplate")
Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox:SetPoint('TOPLEFT', 330, -90)
AleriGuildPlayerFrameRoleFrameShowOffSpecCheckBoxText:SetText('Off Spec')
Aleri.Guild.PlayerFrame.RoleFrame.ShowOffSpecCheckBox:SetScript('OnClick', function() Aleri.GuildInfo(Aleri.Guild.ShowDataRange) end)

Aleri.Guild.PlayerFrame.RoleFrame.TankIcon = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameTankIcon', 'OVERLAY', 'GameFontNormal')
Aleri.Guild.PlayerFrame.RoleFrame.TankIcon:SetText('Tanks') --(Aleri.TankIcon)
Aleri.Guild.PlayerFrame.RoleFrame.TankIcon:SetTextColor(1,1,1)
Aleri.Guild.PlayerFrame.RoleFrame.TankIcon:SetPoint('TOPLEFT', role_icons_left_margin, (-4 * vert_spacing) - role_class_vert_offset)
Aleri.Guild.PlayerFrame.RoleFrame.TankIcon:SetFont("Fonts\\FRIZQT__.TTF", (18 * font_scale))

Aleri.Guild.PlayerFrame.RoleFrame.MeleeDamageIcon = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameMeleeDamageIcon', 'OVERLAY', 'GameFontNormal')
Aleri.Guild.PlayerFrame.RoleFrame.MeleeDamageIcon:SetText('Melee DPS') --(Aleri.DamageIcon)
Aleri.Guild.PlayerFrame.RoleFrame.MeleeDamageIcon:SetTextColor(1,1,1)
Aleri.Guild.PlayerFrame.RoleFrame.MeleeDamageIcon:SetPoint('TOPLEFT', role_icons_left_margin, (-64 * vert_spacing)  - role_class_vert_offset)
Aleri.Guild.PlayerFrame.RoleFrame.MeleeDamageIcon:SetFont("Fonts\\FRIZQT__.TTF", (18 * font_scale))

Aleri.Guild.PlayerFrame.RoleFrame.HealerIcon = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameHealerIcon', 'OVERLAY', 'GameFontNormal')
Aleri.Guild.PlayerFrame.RoleFrame.HealerIcon:SetText('Healers') --(Aleri.HealerIcon)
Aleri.Guild.PlayerFrame.RoleFrame.HealerIcon:SetTextColor(1,1,1)
Aleri.Guild.PlayerFrame.RoleFrame.HealerIcon:SetPoint('TOPLEFT', role_icons_left_margin, (-124 * vert_spacing)  - role_class_vert_offset)
Aleri.Guild.PlayerFrame.RoleFrame.HealerIcon:SetFont("Fonts\\FRIZQT__.TTF", (18 * font_scale))

Aleri.Guild.PlayerFrame.RoleFrame.RangeDamageIcon = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameRangeDamageIcon', 'OVERLAY', 'GameFontNormal')
Aleri.Guild.PlayerFrame.RoleFrame.RangeDamageIcon:SetText('Range DPS') --(Aleri.DamageIcon)
Aleri.Guild.PlayerFrame.RoleFrame.RangeDamageIcon:SetTextColor(1,1,1)
Aleri.Guild.PlayerFrame.RoleFrame.RangeDamageIcon:SetPoint('TOPLEFT', role_icons_left_margin, (-184 * vert_spacing)  - role_class_vert_offset)
Aleri.Guild.PlayerFrame.RoleFrame.RangeDamageIcon:SetFont("Fonts\\FRIZQT__.TTF", (18 * font_scale))

Aleri.Guild.SpecRoleCountFontString = { 
	Tank =  { DEATHKNIGHT = nil, WARRIOR = nil, DRUID = nil, PALADIN = nil },
	Melee =  { DEATHKNIGHT = nil, WARRIOR = nil, DRUID = nil, PALADIN = nil, SHAMAN = nil, ROGUE = nil },
	Healer = { PRIEST = nil, DRUID = nil, SHAMAN = nil, PALADIN = nil },
	Range = { PRIEST = nil, DRUID = nil, SHAMAN = nil, HUNTER = nil, MAGE = nil, WARLOCK = nil }
}

for k, v in ipairs(Aleri.Class.TankIDs) do
	local f = CreateFrame('FRAME', 'AleriGuildPlayerFrameRoleFrameTankRoleClassIcon'..k, Aleri.Guild.PlayerFrame.RoleFrame)
	f:SetPoint('TOPLEFT', (((k - 1) * role_icon_offset) * 30) + role_icons_left_margin, (-24 * vert_spacing) - role_class_vert_offset)
	f:SetSize(icon_size, icon_size)
	local t = f:CreateTexture('$parent_Texture', 'BACKGROUND')
	t:SetAllPoints(f)
	t:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..v)
	
	if v ~= 'Total' then
		local fs = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameTankCountFontString'..v, 'OVERLAY', 'GameFontNormal')
		fs:SetPoint('TOPLEFT', (((k - 1) * role_icon_offset) * 30) + ( 35 + role_icons_left_margin), (-30 * vert_spacing) - role_class_vert_offset)
		fs:SetText(0)
		fs:SetTextColor(1,1,1)
		fs:SetFont("Fonts\\FRIZQT__.TTF", (18 * font_scale))
		Aleri.Guild.SpecRoleCountFontString.Tank[v] = fs
	end
	
end
for k, v in ipairs(Aleri.Class.MeleeDpsIDs) do
	local f = CreateFrame('FRAME', 'AleriGuildPlayerFrameRoleFrameTankRoleClassIcon'..k, Aleri.Guild.PlayerFrame.RoleFrame)
	f:SetPoint('TOPLEFT', (((k - 1) * role_icon_offset) * 30) + role_icons_left_margin, (-84 * vert_spacing) - role_class_vert_offset)
	f:SetSize(icon_size, icon_size)
	local t = f:CreateTexture('$parent_Texture', 'BACKGROUND')
	t:SetAllPoints(f)
	t:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..v)
	
	if v ~= 'Total' then
		local fs = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameTankCountFontString'..v, 'OVERLAY', 'GameFontNormal')
		fs:SetPoint('TOPLEFT', (((k - 1) * role_icon_offset) * 30) + ( 35 + role_icons_left_margin), (-90 * vert_spacing) - role_class_vert_offset)
		fs:SetText(0)
		fs:SetTextColor(1,1,1)
		fs:SetFont("Fonts\\FRIZQT__.TTF", (18 * font_scale))
		Aleri.Guild.SpecRoleCountFontString.Melee[v] = fs
	end
end
for k, v in ipairs(Aleri.Class.HealerIDs) do
	local f = CreateFrame('FRAME', 'AleriGuildPlayerFrameRoleFrameTankRoleClassIcon'..k, Aleri.Guild.PlayerFrame.RoleFrame)
	f:SetPoint('TOPLEFT', (((k - 1) * role_icon_offset) * 30) + role_icons_left_margin, (-144 * vert_spacing	) - role_class_vert_offset)
	f:SetSize(icon_size, icon_size)
	local t = f:CreateTexture('$parent_Texture', 'BACKGROUND')
	t:SetAllPoints(f)
	t:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..v)
	
	if v ~= 'Total' then
		local fs = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameTankCountFontString'..v, 'OVERLAY', 'GameFontNormal')
		fs:SetPoint('TOPLEFT', (((k - 1) * role_icon_offset) * 30) + ( 35 + role_icons_left_margin), (-150 * vert_spacing) - role_class_vert_offset)
		fs:SetText(0)
		fs:SetTextColor(1,1,1)
		fs:SetFont("Fonts\\FRIZQT__.TTF", (18 * font_scale))
		Aleri.Guild.SpecRoleCountFontString.Healer[v] = fs
	end
end
for k, v in ipairs(Aleri.Class.RangeDpsIDs) do
	local f = CreateFrame('FRAME', 'AleriGuildPlayerFrameRoleFrameTankRoleClassIcon'..k, Aleri.Guild.PlayerFrame.RoleFrame)
	f:SetPoint('TOPLEFT', (((k - 1) * role_icon_offset) * 30) + role_icons_left_margin, (-204 * vert_spacing) - role_class_vert_offset)
	f:SetSize(icon_size, icon_size)
	local t = f:CreateTexture('$parent_Texture', 'BACKGROUND')
	t:SetAllPoints(f)
	t:SetTexture("Interface\\Addons\\Aleri\\ClassIcons\\"..v)

	if v ~= 'Total' then
		local fs = Aleri.Guild.PlayerFrame.RoleFrame:CreateFontString('AleriGuildPlayerFrameRoleFrameTankCountFontString'..v, 'OVERLAY', 'GameFontNormal')
		fs:SetPoint('TOPLEFT', (((k - 1) * role_icon_offset) * 30) + ( 35 + role_icons_left_margin), (-210 * vert_spacing) - role_class_vert_offset)
		fs:SetText(0)
		fs:SetTextColor(1,1,1)
		fs:SetFont("Fonts\\FRIZQT__.TTF", (18 * font_scale))
		Aleri.Guild.SpecRoleCountFontString.Range[v] = fs
	end
end


-------------------------------------------------------------------------------------------------------
--RAID STATS SCROLL FRAME
-------------------------------------------------------------------------------------------------------
Aleri.Guild.PlayerFrame.RaidStatsFrame = CreateFrame('FRAME', 'AleriGuildPlayerFrameRaidStatsFrame', Aleri.Guild.PlayerFrame)
Aleri.Guild.PlayerFrame.RaidStatsFrame:SetPoint('TOPLEFT', -5, 8)
Aleri.Guild.PlayerFrame.RaidStatsFrame:SetSize(478, 415)
-- Aleri.Guild.PlayerFrame.RaidStatsFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            -- edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            -- tile = true, tileSize = 8, edgeSize = 8, 
                                            -- insets = { left = 2, right = 2, top = 2, bottom = 2 }});
-- Aleri.Guild.PlayerFrame.RaidStatsFrame:SetBackdropColor(1,1,1,0.1)

Aleri.Guild.PlayerFrame.RaidStatsGridView = {}
Aleri.Guild.PlayerFrame.RaidStatsColumns = { 'Id', 'ClassIcon', 'ClassIconTexture', 'Name', 'MainSpec', 'MainSpecGearScore', 'Net', 'Tot', 'Hrs', 'OffSpec', 'OffSpecGearScore', 'Alt', 'DKP'}

Aleri.Guild.PlayerFrame.RaidStatsFrame.NameSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameGearScoreSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
Aleri.Guild.PlayerFrame.RaidStatsFrame.NameSortButton:SetPoint('TOPLEFT', 30, -24)
Aleri.Guild.PlayerFrame.RaidStatsFrame.NameSortButton:SetSize(80, 20)
Aleri.Guild.PlayerFrame.RaidStatsFrame.NameSortButton:SetText('Name')
Aleri.Guild.PlayerFrame.RaidStatsFrame.NameSortButton:SetScript('OnClick', function(self) Aleri.Guild.RaidStatsSort = self:GetText() Aleri.GuildRaidStatsInfo(self:GetText()) end)

Aleri.Guild.PlayerFrame.RaidStatsFrame.ClassSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameGearScoreSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
Aleri.Guild.PlayerFrame.RaidStatsFrame.ClassSortButton:SetPoint('TOPLEFT', 110, -24)
Aleri.Guild.PlayerFrame.RaidStatsFrame.ClassSortButton:SetSize(40, 20)
Aleri.Guild.PlayerFrame.RaidStatsFrame.ClassSortButton:SetText('Class')
Aleri.Guild.PlayerFrame.RaidStatsFrame.ClassSortButton:SetScript('OnClick', function(self) Aleri.Guild.RaidStatsSort = self:GetText() Aleri.GuildRaidStatsInfo(self:GetText()) end)

Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameMainSpecSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecSortButton:SetPoint('TOPLEFT', 150, -24)
Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecSortButton:SetSize(90, 20)
Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecSortButton:SetText('Main Spec')
Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecSortButton:SetScript('OnClick', function(self) Aleri.Guild.RaidStatsSort = 'MainSpec' Aleri.GuildRaidStatsInfo('MainSpec') end)

Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecGearScoreSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameMainSpecGearScoreSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecGearScoreSortButton:SetPoint('TOPLEFT', 240, -24)
Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecGearScoreSortButton:SetSize(40, 20)
Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecGearScoreSortButton:SetText('GS')
Aleri.Guild.PlayerFrame.RaidStatsFrame.MainSpecGearScoreSortButton:SetScript('OnClick', function(self) Aleri.Guild.RaidStatsSort = 'MainSpecGearScore' Aleri.GuildRaidStatsInfo('MainSpecGearScore') end)

Aleri.Guild.PlayerFrame.RaidStatsFrame.GearScoreSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameOffSpecGearScoreSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
Aleri.Guild.PlayerFrame.RaidStatsFrame.GearScoreSortButton:SetPoint('TOPLEFT', 280, -24)
Aleri.Guild.PlayerFrame.RaidStatsFrame.GearScoreSortButton:SetSize(90, 20)
Aleri.Guild.PlayerFrame.RaidStatsFrame.GearScoreSortButton:SetText('Off Spec')
Aleri.Guild.PlayerFrame.RaidStatsFrame.GearScoreSortButton:SetScript('OnClick', function(self) Aleri.Guild.RaidStatsSort = 'OffSpec' Aleri.GuildRaidStatsInfo('OffSpec') end)

Aleri.Guild.PlayerFrame.RaidStatsFrame.OffSpecGearScoreSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameOffSpecGearScoreSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
Aleri.Guild.PlayerFrame.RaidStatsFrame.OffSpecGearScoreSortButton:SetPoint('TOPLEFT', 370, -24)
Aleri.Guild.PlayerFrame.RaidStatsFrame.OffSpecGearScoreSortButton:SetSize(40, 20)
Aleri.Guild.PlayerFrame.RaidStatsFrame.OffSpecGearScoreSortButton:SetText('GS')
Aleri.Guild.PlayerFrame.RaidStatsFrame.OffSpecGearScoreSortButton:SetScript('OnClick', function(self) Aleri.Guild.RaidStatsSort = 'OffSpecGearScore' Aleri.GuildRaidStatsInfo('OffSpecGearScore') end)

Aleri.Guild.PlayerFrame.RaidStatsFrame.DKPSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameNetSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
Aleri.Guild.PlayerFrame.RaidStatsFrame.DKPSortButton:SetPoint('TOPLEFT', 410, -24)
Aleri.Guild.PlayerFrame.RaidStatsFrame.DKPSortButton:SetSize(50, 20)
Aleri.Guild.PlayerFrame.RaidStatsFrame.DKPSortButton:SetText('DKP')
Aleri.Guild.PlayerFrame.RaidStatsFrame.DKPSortButton:SetScript('OnClick', function(self) Aleri.Guild.RaidStatsSort = self:GetText() Aleri.GuildRaidStatsInfo(self:GetText()) end)

-- Aleri.Guild.PlayerFrame.RaidStatsFrame.TotSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameTotSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
-- Aleri.Guild.PlayerFrame.RaidStatsFrame.TotSortButton:SetPoint('TOPLEFT', 460, -24)
-- Aleri.Guild.PlayerFrame.RaidStatsFrame.TotSortButton:SetSize(50, 20)
-- Aleri.Guild.PlayerFrame.RaidStatsFrame.TotSortButton:SetText('Tot')
-- Aleri.Guild.PlayerFrame.RaidStatsFrame.TotSortButton:SetScript('OnClick', function(self) Aleri.Guild.RaidStatsSort = self:GetText() Aleri.GuildRaidStatsInfo(self:GetText()) end)

-- Aleri.Guild.PlayerFrame.RaidStatsFrame.HrsSortButton = CreateFrame("BUTTON", "AleriGuildPlayerFrameRaidStatsFrameHrsSortButton", Aleri.Guild.PlayerFrame.RaidStatsFrame, "UIPanelButtonTemplate")
-- Aleri.Guild.PlayerFrame.RaidStatsFrame.HrsSortButton:SetPoint('TOPLEFT', 412, -24)
-- Aleri.Guild.PlayerFrame.RaidStatsFrame.HrsSortButton:SetSize(50, 20)
-- Aleri.Guild.PlayerFrame.RaidStatsFrame.HrsSortButton:SetText('Hrs')
-- Aleri.Guild.PlayerFrame.RaidStatsFrame.HrsSortButton:SetScript('OnClick', function(self) Aleri.GuildRaidStatsInfo(self:GetText()) end)

--SCROLL FRAME
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame = CreateFrame('ScrollFrame', 'AleriGuildPlayerFrameRaidStatsFrameScrollFrame', Aleri.Guild.PlayerFrame.RaidStatsFrame)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame:SetPoint('TOPLEFT', 4, -44)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame:SetPoint('BOTTOMRIGHT', -4, 4)

Aleri.Guild.PlayerFrame.RaidStatsFrame.scrollframe = Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame

--SCROLLBAR
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar = CreateFrame("Slider", 'AleriGuildPlayerFrameRaidStatsFrameScrollBar', Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame, "UIPanelScrollBarTemplate")
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetPoint("TOPLEFT", Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame, "TOPRIGHT", -12,-12) 
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetPoint("BOTTOMLEFT", Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame, "BOTTOMRIGHT", -12,16)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetMinMaxValues(1, 100)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetValueStep(1)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar.scrollStep = 1
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetValue(1)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetWidth(16)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetScript('OnValueChanged', function(self, value) 
	self:GetParent():SetVerticalScroll((Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent:GetHeight() / 100) * value)
	--print('scroll bar value', value)
	if value == 1 then
		self:GetParent():SetVerticalScroll(1)
	elseif value == 100 then
		self:GetParent():SetVerticalScroll(Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent:GetHeight())
	end
end )
--mouse scroll wheel function
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame:EnableMouseWheel(1)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame:SetScript('OnMouseWheel', function(self, value) 
local v_mouse_scroll = Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:GetValue()
	if value == 1 then
		Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetValue(v_mouse_scroll - 1)
		--print(self:GetVerticalScroll())
	elseif value == -1 then
		Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:SetValue(v_mouse_scroll + 1)
		--print(self:GetVerticalScroll())
	end
end)


local scrollBarTexture = Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar:CreateTexture('AleriGuildPlayerFrameRaidStatsFrameScrollBarTexture', 'BACKGROUND')
scrollBarTexture:SetAllPoints(Aleri.Guild.PlayerFrame.RaidStatsFrameScrollBar)
scrollBarTexture:SetTexture(0, 0, 0, 0.4)
Aleri.Guild.PlayerFrame.RaidStatsFrame.scrollbar = scrollBarTexture

--SCROLL FRAM ECONTENT FRAME
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent = CreateFrame('FRAME', 'AleriGuildPlayerFrameRaidStatsFrameScrollFrameContent', Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame)
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent:SetSize(430, 460)

Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame.content = Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent
Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrame:SetScrollChild(Aleri.Guild.PlayerFrame.RaidStatsFrameScrollFrameContent)
-------------------------------------------------------------------------------------------------------



-------------------------------------------------------------------------------------------------------
-- Aleri Guild Player frame Tab Set Up
-------------------------------------------------------------------------------------------------------
Aleri.Guild.PlayerFrame.TabButtons = {}

Aleri.Guild.PlayerFrame.ClassSummaryTabButton = CreateFrame('BUTTON', '$parentTab1', Aleri.Guild.PlayerFrame, 'CharacterFrameTabButtonTemplate')
Aleri.Guild.PlayerFrame.ClassSummaryTabButton:SetPoint('BOTTOMLEFT', 4, -30)
Aleri.Guild.PlayerFrame.ClassSummaryTabButton:SetText('Class Summary')
Aleri.Guild.PlayerFrame.ClassSummaryTabButton:SetFrameStrata('BACKGROUND')
Aleri.Guild.PlayerFrame.ClassSummaryTabButton:SetScript('OnClick', function(self) Aleri.Guild.PlayerFrame.TabButtonsUpdateUI(self) Aleri.Guild.PlayerFrameDropDown:Show() end)
table.insert(Aleri.Guild.PlayerFrame.TabButtons, { Id = 1, Button = Aleri.Guild.PlayerFrame.ClassSummaryTabButton, Frame = Aleri.Guild.ClassStatsFrame } )

Aleri.Guild.PlayerFrame.RoleSummaryTabButton = CreateFrame('BUTTON', '$parentTab2', Aleri.Guild.PlayerFrame, 'CharacterFrameTabButtonTemplate')
Aleri.Guild.PlayerFrame.RoleSummaryTabButton:SetPoint('BOTTOMLEFT', 114, -30)
Aleri.Guild.PlayerFrame.RoleSummaryTabButton:SetText('Specs & Roles')
Aleri.Guild.PlayerFrame.RoleSummaryTabButton:SetFrameStrata('BACKGROUND')
Aleri.Guild.PlayerFrame.RoleSummaryTabButton:SetScript('OnClick', function(self) Aleri.Guild.PlayerFrame.TabButtonsUpdateUI(self) Aleri.Guild.PlayerFrameDropDown:Show() end)
table.insert(Aleri.Guild.PlayerFrame.TabButtons, { Id = 2, Button = Aleri.Guild.PlayerFrame.RoleSummaryTabButton, Frame = Aleri.Guild.PlayerFrame.RoleFrame } )

Aleri.Guild.PlayerFrame.RaidStatsTabButton = CreateFrame('BUTTON', '$parentTab3', Aleri.Guild.PlayerFrame, 'CharacterFrameTabButtonTemplate')
Aleri.Guild.PlayerFrame.RaidStatsTabButton:SetPoint('BOTTOMLEFT', 214, -30)
Aleri.Guild.PlayerFrame.RaidStatsTabButton:SetText('Gear Scores')
Aleri.Guild.PlayerFrame.RaidStatsTabButton:SetFrameStrata('BACKGROUND')
Aleri.Guild.PlayerFrame.RaidStatsTabButton:SetScript('OnClick', function(self) Aleri.Guild.PlayerFrame.TabButtonsUpdateUI(self) Aleri.Guild.PlayerFrameDropDown:Hide() end)
table.insert(Aleri.Guild.PlayerFrame.TabButtons, { Id = 3, Button = Aleri.Guild.PlayerFrame.RaidStatsTabButton, Frame = Aleri.Guild.PlayerFrame.RaidStatsFrame } )

function Aleri.Guild.PlayerFrame.TabButtonsUpdateUI(active_button)
	for k, button in ipairs(Aleri.Guild.PlayerFrame.TabButtons) do
		if button.Button ~= active_button then
			button.Button:SetFrameStrata('BACKGROUND')
			button.Frame:Hide()
		else
			button.Button:SetFrameStrata('HIGH')
			button.Frame:Show()
		end
	end	
end
-------------------------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------------------------
-- Merchant Functions
-------------------------------------------------------------------------------------------------------
function Aleri.Merchant.SellJunk()
	for bag = 0, 4 do
		for slot = 1, GetContainerNumSlots(bag) do 
			local item_link = GetContainerItemLink(bag,slot) 
			if item_link and select(3, GetItemInfo(item_link)) == 0 then
				UseContainerItem(bag,slot)
			end
		end
	end
end

Aleri.Merchant.SellJunkButton = CreateFrame("BUTTON", "AleriMerchantSellJunkButton", MerchantFrame, "UIPanelButtonTemplate")
Aleri.Merchant.SellJunkButton:SetText('|cFFFFFFFFSell Junk|r')
Aleri.Merchant.SellJunkButton:SetPoint("TOPLEFT", 80, -42)
Aleri.Merchant.SellJunkButton:SetSize(80, 25)
Aleri.Merchant.SellJunkButton:SetScript('OnClick', function() Aleri.Merchant.SellJunk() end)
-------------------------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------------------------
-- Mail Functions
-------------------------------------------------------------------------------------------------------
function Aleri.Mail.TakeAuctionSoldGold()
	for mail = GetInboxNumItems(), 1, -1 do
		_, _, Aleri.Mail.Sender, Aleri.Mail.Subject, Aleri.Mail.Currency = GetInboxHeaderInfo(mail)
		if string.find(Aleri.Mail.Subject, 'Auction successful') then
			--print('Sold '..string.sub(Aleri.Mail.Subject, 21)..' for '..GetCoinTextureString(Aleri.Mail.Currency))
			TakeInboxMoney(mail)			
		end
	end			
end

function Aleri.Mail.TakeAuctionWonItems()
	for mail = GetInboxNumItems(), 1, -1 do
		_, _, Aleri.Mail.Sender, Aleri.Mail.Subject, Aleri.Mail.Currency = GetInboxHeaderInfo(mail)
		if string.find(Aleri.Mail.Subject, 'Auction won') then
			--print()
			TakeInboxItem(mail)			
		end
	end			
end

Aleri.Mail.TakeGoldButton = CreateFrame("BUTTON", "AleriMailTakeGoldButton", InboxFrame, "UIPanelButtonTemplate")
Aleri.Mail.TakeGoldButton:SetText('|cFFFFFFFFAH Gold|r')
Aleri.Mail.TakeGoldButton:SetPoint("TOPLEFT", 80, -42)
Aleri.Mail.TakeGoldButton:SetSize(80, 25)
Aleri.Mail.TakeGoldButton:SetScript('OnClick', function() Aleri.Mail.TakeAuctionSoldGold() end)

Aleri.Mail.TakeAuctionWonItemsButton = CreateFrame("BUTTON", "AleriMailTakeAuctionWonItemsButton", InboxFrame, "UIPanelButtonTemplate")
Aleri.Mail.TakeAuctionWonItemsButton:SetText('|cFFFFFFFFAH Items|r')
Aleri.Mail.TakeAuctionWonItemsButton:SetPoint("TOPLEFT", 170, -42)
Aleri.Mail.TakeAuctionWonItemsButton:SetSize(80, 25)
Aleri.Mail.TakeAuctionWonItemsButton:SetScript('OnClick', function() Aleri.Mail.TakeAuctionWonItems() end) -- Aleri.Mail.TakeAuctionWonItems() end)
-------------------------------------------------------------------------------------------------------

Aleri.Guild.PublicNotes = {}

StaticPopupDialogs['UpdatePublicNote'] = {
	text = 'Update Public Note for - %s \n \n %s',
	button1 = 'OK',
	OnAccept = function() print('yay') end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	preferredIndex = 3,
	}


-------------------------------------------------------------------------------------------------------
-- Events
-------------------------------------------------------------------------------------------------------
function Aleri.OnEvent(self, event, ...)

	if event == 'ADDON_LOADED' and select(1, ...) == 'Aleri' then
		print('|cff628B57Aleri loaded')
		Aleri.Guild.PlayerFrameDropDown_Init()
		for k, tab in ipairs(Aleri.Guild.PlayerFrame.TabButtons) do 
			if tab.Id == 1 then
				tab.Button:SetFrameStrata('HIGH')
				tab.Frame:Show()
			else
				tab.Button:SetFrameStrata('BACKGROUND')
				tab.Frame:Hide()
			end
		end
		-- TO USE GUILD CHAT DROP DOWN QUICK MESSAGES UN COMMENT THIS
		--Aleri.Chat.GuildChatDropDown_Init()
		
		Aleri.MakeFrameMove(Aleri.Guild.PlayerFrame)
	end
	
	if event == "GUILD_ROSTER_UPDATE" and Aleri.Guild.PlayerFrame:IsVisible() == 1 then		
		Aleri.GuildInfo(Aleri.Guild.ShowDataRange)
		Aleri.GuildRaidStatsInfo('refresh')
	end

	if event == 'CHAT_MSG_WHISPER' then
		local sender = select(2, ...)
		local msg = select(1, ...)
		if Aleri.ThisPlayer.RankIndex == 1 then
			if string.find(msg, '-myspecs') then
				local i = 0
				for data in string.gmatch(msg, "%S+") do
					if i == 1 then _ms = string.lower(data) end
					if i == 2 then
						if data == '-' then
							_msgs = 0
						else
							_msgs = string.sub(data, 1, 3)
						end
					end
					if i == 3 then _os = string.lower(data) end
					if i == 4 then
						if data == '-' then
							_osgs = 0
						else
							_osgs = string.sub(data, 1, 3)
						end
					end
					i = i + 1
				end
				StaticPopup_Show ("UpdatePublicNote", sender, msg)
			end
			--table.insert(Aleri.Guild.PublicNotes, { Name = sender, MainSpec = _ms, MainSpecGearScore = _msgs, OffSpec = _os, OffSpecGearScore = _osgs } )
		end
	end
	
end

Aleri.MainFrame:SetScript('OnEvent', Aleri.OnEvent)
-------------------------------------------------------------------------------------------------------


-------------------------------------------------------------------------------------------------------
-- Slash Commands
-------------------------------------------------------------------------------------------------------
SLASH_ALERI1 = '/aleri'
SlashCmdList['ALERI'] = function(msg)
	if string.find(msg, 'help') then
		print('use \\aleri plus any of the following')
		print('-setscaleX.X this will set the main scale to the value of X.X (0.3 - 1.0)')

	elseif string.find(msg, '-setscale') then
		local scale  = (string.sub(msg, 10, 12))
		if string.find(scale, ',') then scale = tostring(string.sub(scale, 1, 1)..'.'..string.sub(scale, 3, 3)) end
		scale = tonumber(scale)
		if scale > 1.1 then 
			scale = 1
		elseif scale < 0.3 then
			scale = 0.3
		end
		Aleri.Guild.PlayerFrame:SetScale(scale)
	end
end